%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         CROSSSUN386-LAP.SL
% Description:  Prefix for crosscompiling for Intel 80386 PSL Assembler
%               on a MC 68020
% Author:       H. Melenk
% Created:      1-Sept 1989
% Modified:
% Mode:         Lisp
% Package:      
% Status:       Experimental (Do Not Distribute)
%
% (c) Copyright 1989, Konrad-Zuse-Zentrum Berlin all rights reserved.
%
 
(compiletime (load fasl-decls sys-consts sys-macros))


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   CROSS-FASL-SECTION
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% This must be here when building the cross fasler.
% because  the 80386 needs words and halfwords the other way stored

(compiletime
% (setprop 'putbyte nil)       
  (setprop 'puthalfword nil)  
  (setprop 'putword nil)     
  (setprop 'putmem nil)
  (setprop 'getmem nil)
% (setprop 'mkitem nil)
  (setprop 'deflist nil)
(put 'getmem 'assign-op 'putmem)
 
)  
                          
(on testlap)   %%%%%% reichlich output

(de puthalfword (adr d w)
     (putbyte adr d (wand w 255))
     (putbyte adr (iadd1 d) (wand (lshift w 8) 255)))
 
(de putword (adr d w)
     (setq adr (wplus2 adr d))
     (putbyte adr 0 (wand w 255))
     (putbyte adr 1 (wand (setq w (wshift w -8)) 255))
     (putbyte adr 2 (wand (setq w (wshift w -8)) 255))
     (putbyte adr 3 (wand (setq w (wshift w -8)) 255)))
                         
(de putmem (adr w) (putword adr 0 w))
 
(de getmem (adr)
    (setq adr (inf adr))
    (wor (byte adr 0)
        (wor (wshift (byte adr 1) 8)
             (wor (wshift (byte adr 2) 16)
                  (wshift (byte adr 3) 24) ))))

(dskin "/keller/cons/psl/dist/comp/sun386/fixup386.sl")

%-------------------------------------------------------------------
% from PXNK:SYSTEM-FASLIN.SL
 

(fluid '(argumentblock))
 

(de depositvaluecelllocation (x)
  (if (not *writingfaslfile)
    (progn (setf (getmem (iplus2 codebase* currentoffset*))
                 (loc (wgetv symval (idinf x))))
           (setf currentoffset* (iplus2 currentoffset* 4)))
    (progn (setf (getmem (iplus2 codebase* currentoffset*))
                 (makerelocword reloc-value-cell (findidnumber x)))
           (setf currentoffset* (iplus2 currentoffset* 4))
           (updatebittable 4 reloc-word))))
 

(de depositextrareglocation (x)
  (if (not *writingfaslfile)
    (progn (setf (getmem (iplus2 codebase* currentoffset*))
                 (loc (wgetv argumentblock
                       (wdifference x (wplus2 maxrealregs 1)))))
           (setf currentoffset* (iplus2 currentoffset* 4)))
    (progn (setf (getmem (iplus2 codebase* currentoffset*))
                 (makerelocword reloc-value-cell (wplus2 x 8150)))
           (setf currentoffset* (iplus2 currentoffset* 4))
           (updatebittable 4 reloc-word))))
 
(de depositfunctioncelllocation (x)
  (if (not *writingfaslfile)
    (progn (setf (getmem (iplus2 codebase* currentoffset*))
                 (iplus2 symfnc (itimes2 6 (idinf x))))
           (setf currentoffset* (iplus2 currentoffset* 4)))
    (progn (setf (getmem (iplus2 codebase* currentoffset*))
                 (makerelocword reloc-function-cell
                  (findidnumber x)))
           (setf currentoffset* (iplus2 currentoffset* 4))
           (updatebittable 4 reloc-word))))
 
 
(copyd 'originalbinarywrite 'binarywrite)
(de binarywrite (f w)
   % big->little endian conversion
    (prog(v)
           % byte 4 -> 1
       (setq v(wshift w 24))
           % byte 3 -> 2
       (setq v (wor v (wshift (wand (wshift 255 8 ) w)  8 )))
           % byte 2 -> 3
       (setq v (wor v (wshift (wand (wshift 255 16) w) -8 )))
           % byte 1 -> 4
       (setq v (wor v (wshift (wand (wshift 255 24) w) -24))) 
       (originalbinarywrite f v)))

       
(loadtime (mapobl 
    (function (lambda(x) (remprop x 'INSTRUCTIONDEPOSITFUNCTION)))))
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%    END-OF-CROSS-FASL-SECTION
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

