C=============================================================================
C  File :   UCOSIO    UNICOS I/O Routines for Cray PSL3.4 UNICOS
C
C  Author:  W. Neun   ZIB Berlin
C
C  Date  :  8. May. 1987
C
C  Copyright (c) Konrad Zuse-Zentrum, 1987, all rights reserved
C =============================================================================
C
C Revision
C
C 2.5.88  removed some function, which are now in kerneletc.c
C 10.7.86 added scheme for dectection of attention interrupts in inter-
C active mode. Variable BRK will tell that:
C  BRK = 0   no critical I/O running
C  BRK > 0   I/O is critical
C  BRK < 0   an attention interrupt has happend
C
C BRK will be read by the reprieve dispatch routine
C
C -----------------------------------------------------------------------------
C    This file should work with both Cray X-MP and Y-MP (UNICOS)
C    So we have to have knowledge about the Size of an A register
CXMP  PARAMETER (AREGSIZE = 24)
CYMP  PARAMETER (AREGSIZE = 32)
C -----------------------------------------------------------------------------
C  BLOCK DATA DEFINITIONS 
C
      BLOCK DATA FNAMES
C
      COMMON /IOSTUF/ BRK,ERR, FILEDN(32), FILEPDN(2,32), INUSE(32)
     *               , IDF(2) , DEFO(3)
C
      COMMON /LIBDIR/ LIBDIR
      CHARACTER*255 LIBDIR
C
      DATA LIBDIR /' '/
C
      DATA INUSE /32*0/
C
      END
C
C -----------------------------------------------------------------------------
C  COS REPRIEVE PROCESSING ROUTINE.  RETURNS ERRORADDRESS
C
      SUBROUTINE COSRPV (TREGPTR,BREGPTR,REGB00,REGT00)
      IMPLICIT INTEGER(A-Z)
      TREG = 0
      CALL COSRPVF (TREGPTR,BREGPTR,REGB00,REGT00,TREG)
      TREGPTR = TREG
      END

      SUBROUTINE COSRPVF (TREGPTR,BREGPTR,REGB00,REGT00,TREG)
C
      IMPLICIT INTEGER(A-Z)
      PARAMETER (AREGSIZE = 32)
C
      COMMON /IOSTUF/ BRK,ERR, FILEDN(32), FILEPDN(2,32), INUSE(32)
     *               , IDF(2) , DEFO(3)
      COMMON /REPREV/XXDUMMY,XDUMMY, XPSAVE(39)
      POINTER (BREGPTR,BREGS),(TREGPTR,TREGS)
      DIMENSION BREGS(64),TREGS(64)
      INTEGER PARCEL(4)
      POINTER (PJCHLM,JCHLM)
      DATA PJCHLM  /  65 /
      DATA MASK1   / 77777777B /
C
C  'MASK' IS A 22-BIT MASK USED TO EXTRACT THE WORD ADDRESS
C  PART OF THE P-ADDRESS FROM THE EXCHANGE PACKAGE.
C  'PARCEL' IS AN ARRAY OF THE PARCEL SPECIFIERS, AND WILL
C  BE INDEXED BY 'NPARCL' (BELOW).
C
      DATA MASK / 17777777B /
      DATA PARCEL / 'a', 'b', 'c', 'd' /
C
C  Get the HLM value from bits 16-39 of JCHLM.Dont dump if P is above
C
      HLM = AND (SHIFTR (JCHLM, 24), MASK1)
C
C  NOW FORMAT & OUTPUT THE SYSTEM ERROR CODE AND THE PROGRAM ADDRESS
C  SO THE USER WILL KNOW WHAT HAPPENED AND WHERE.
C  If TREGPTR = -1 no message will be shown , just set new RPV
C  if TREGPTR = 0 a short errormessage should occur
C
      PADDR  = AND(SHIFTR(XPSAVE(1),AREGSIZE+2), MASK)
      PADDR1 = AND(SHIFTR(XPSAVE(1),AREGSIZE), MASK)
      NPARCL = AND(SHIFTR(XPSAVE(1),AREGSIZE), 3)
      NPARCL = NPARCL + 1
      IF(TREGPTR.EQ.-1) GOTO 1238
C
      WRITE (101,30) XPSAVE(38)
   30 FORMAT(///' ','*** UNEXPECTED INTERRUPT ***'/
     *          ' ','*** SYSTEM SIGNAL NUMBER = ',I3)
C
      IF(TREGPTR.EQ.0) GOTO 1238
C
      WRITE (101,301) PADDR, PARCEL(NPARCL),PADDR1,
     *               REGB00/4,REGB00
  301 FORMAT(   ' ','PROGRAM ADDRESS = ',O8,A1,
     *          ' ',' equiv. parceladdress ',O8,/,
     *          ' ','CALLED FROM       ',O8,
     *          ' ','  equiv. parceladdress ',O8,/)
      DO 1234 I=1,8
      WRITE (101,'(A,I1,A,O8,A,I1,A,O22)') '  A(',I-1,') = ',
     *         AND(XPSAVE(I),77777777B)
     * ,'   S(',I-1,') = ',XPSAVE(I+8)
1234  CONTINUE
C
      WRITE (101,'(/,A,I2,A,O22)') '  VL = ',AND(SHIFTR(XPSAVE(4),33),
     *    63)                                 ,'   VM = ',XPSAVE(17)
      WRITE (101,'(/,2(A,O22))') '  T(00) = ',REGT00,
     * '  T(01) = ',TREGS(2)
      DO 1236 I=4,64,2
      WRITE (101,'(2(A,O2,A,O22))') '  T(',I-2,') = ',TREGS(I-1),
     * '  T(',I-1,') = ',TREGS(I)
1236  CONTINUE
C
      WRITE (101,'(/,3(A,O8))') '  B(00) = ',REGB00,
     * '   B(01) = ',BREGS(2),'   B(02) = ',BREGS(3)
      DO 1237 I=3,60,3
      WRITE (101,'(3(A,O2,A,O8))') '  B(',I,') = ',BREGS(I+1),
     * '   B(',I+1,') = ',BREGS(I+2),'   B(',I+2,') = ',BREGS(I+3)
1237  CONTINUE
      WRITE (101,'(A,O8,/)') '  B(77) = ',BREGS(65)
C
C make a Pdump is requested and possible
C
CCCCC      IF(PADDR.LT.HLM-1000)
CCCCC     *             CALL PDUMP(MAX(0,PADDR-20),PADDR+20,7)
C
C Return erroraddress and ABcode to LISP
C

1238  TREG =SHIFTL(XPSAVE(38),32)+PADDR
      RETURN
      END
C
C -----------------------------------------------------------------------------
C  GET AN AVAILABLE I/O CHANNEL (IOC).  FOR COS, THIS IS JUST A UNIT NUMBER,
C  BUT WE HAVE TO KEEP TRACK OF THEM SO WE KNOW WHICH ONES ARE AVAILABLE.
C
      SUBROUTINE COSIOC (IOC)
C
      IMPLICIT INTEGER(A-Z)
      COMMON /IOSTUF/ BRK,ERR, FILEDN(32), FILEPDN(2,32), INUSE(32)
     *               , IDF(2) , DEFO(3)
C
C  LOOK FOR AN AVAILABLE I/O CHANNEL.
C  WE BIAS THE CHANNEL NUMBERS BY 60, SO THAT THE FIRST ONE WILL BE 61.
C  THIS WILL HELP PREVENT UNIT NUMBER COLLISIONS WITH OTHER FORTRAN JOBS.
C  NOTE THAT THESE ARE REALLY FORTRAN UNIT NUMBERS.
C
      DO 10 I = 1, 32
      IF (INUSE(I) .EQ. 0) THEN
        IOC = I
        RETURN
      ENDIF
   10 CONTINUE
C
C  COULDN'T FIND ONE, SO SET THE ERROR FLAG
C
      ERR = -1
C
      RETURN
      END
C
C
C -----------------------------------------------------------------------------
C     Set path for Library access (UNICOS)
C
      SUBROUTINE COSOWN (STRPTR)
C
      INTEGER STRPTR
      COMMON /LIBDIR/ LIBDIR
      CHARACTER *255 LIBDIR
C EXPANDNM is an entry in kernletc.c
      III = AND(77777777777b, STRPTR + 1)
      CALL NAMETRF(EXPANDNM(III     ),LIBDIR)
      RETURN
      END
C
C -----------------------------------------------------------------------------
C  READ A RECORD FROM THE TERMINAL.
      SUBROUTINE COSTERMR (SIZ, PSTRING)
C
      IOC = -1
      CALL COSREADR (SIZ, PSTRING, IOC)
C
      RETURN
      END
C
C -----------------------------------------------------------------------------
C  WRITE A RECORD TO THE TERMINAL.
C
      SUBROUTINE COSTERMW (SIZ, PSTRING)
C
      IOC = -1
      CALL COSWRITR (SIZ, PSTRING, IOC)
C
      RETURN
      END
C------------------------------------------------------------------
C  return and reset the IO error status, use for library files only
C------------------------------------------------------------------
      SUBROUTINE COSCKERR (RETERR)
C
      IMPLICIT INTEGER(A-Z)
      COMMON /IOSTUF/ BRK,ERR, FILEDN(32), FILEPDN(2,32), INUSE(32)
     *               , IDF(2) , DEFO(3)
C
      RETERR = ERR
      ERR = 0
      RETURN
      END
C
C  SET POSITION IN 'STAT' FOR I/O.
C  NOT NEEDED FOR COS.
C
      SUBROUTINE COSSTPOS (IOC, NUMBER)
C
      RETURN
      END
C
C -----------------------------------------------------------------------------
C  Package for object-module-libraries.  Done by wordaddressable
C  Files. The calling conventions are slightly different from SYSIO
C
      SUBROUTINE COSWOPR (NAMEPTR,BUFSIZ)
C
      IMPLICIT INTEGER(A-Z)
      INTEGER BUFSIZ
      DIMENSION FILENAME(2)
      POINTER (NAMEPTR,FILENAME)
      COMMON /IOSTUF/ BRK,ERR, FILEDN(32), FILEPDN(2,32), INUSE(32)
     *               , IDF(2) , DEFO(3)
      COMMON /LIBDA/LIBDA
      LOGICAL LIBDA
C
      CALL COSIOC(IOC)
      CALL COSCKERR(III)
      IF(III.NE.0) THEN
           NAMEPTR=-1
           RETURN
           ENDIF
C
      CALL LIBNAME(EXPANDNM(NAMEPTR),IOC)
      FILEDN(IOC) = IOC+60
C
123   IF (LIBDA) CALL WOPEN(FILEDN(IOC),BUFSIZ,0,ERR)
C
      IF(.NOT. LIBDA .OR. ERR.NE.0) THEN
      NAMEPTR=-1
      ERR = 0
      INUSE(IOC)=0
      ELSE
      NAMEPTR=IOC
      INUSE(IOC)=11
      ENDIF
C
C  delete file environment
C
      CALL RMWIPF
 
      RETURN
      END
C
C -----------------------------------------------------------------------------
      SUBROUTINE COSWOPW (NAMEPTR,MODUS,BUFSIZ)
C
      IMPLICIT INTEGER(A-Z)
      INTEGER BUFSIZ
      DIMENSION FILENAME(2)
      POINTER (NAMEPTR,FILENAME)
      COMMON /IOSTUF/ BRK,ERR, FILEDN(32), FILEPDN(2,32), INUSE(32)
     *               , IDF(2) , DEFO(3)
      COMMON /LIBDA/LIBDA
      LOGICAL LIBDA
C
C
      CALL COSIOC(IOC)
      CALL COSCKERR(III)
      IF(III.NE.0) THEN
           NAMEPTR=-1
           RETURN
           ENDIF
C
      CALL LIBNAME(EXPANDNM(NAMEPTR),IOC)
      FILEDN(IOC) = IOC+60
 
C Modus = 0 requires, that the library must exist
 
      IF((.NOT.LIBDA).AND.(MODUS.EQ.0)) THEN
      INUSE(IOC)=0
      NAMEPTR = -1
      RETURN
      ELSE
C
      CALL WOPEN(FILEDN(IOC),BUFSIZ,0,ERR)
C
      ENDIF
      IF(ERR.NE.0) THEN
      NAMEPTR=-1
      INUSE(IOC)=0
      ERR = 0
      ELSE
      NAMEPTR=IOC
      INUSE(IOC)=11
      ENDIF
C
C  delete file environment
C
      CALL RMWIPF
 
      IF (.NOT.LIBDA) NAMEPTR=-IOC
 
C Returning negative number ( < -1) when opened new
 
      RETURN
      END
C
C -----------------------------------------------------------------------------
      SUBROUTINE COSWREW (IOC,IADDR)
C
      IMPLICIT INTEGER(A-Z)
      COMMON /IOSTUF/ BRK,ERR, FILEDN(32), FILEPDN(2,32), INUSE(32)
     *               , IDF(2) , DEFO(3)
C
      BRK = 17
      CALL GETWA(FILEDN(IOC),III,IADDR,1,ERR)
      IOC=III
      IF(ERR.NE.0) THEN
        WRITE(101,'(A)') ' *** Error reading library file'
        IOC=-1
        ERR = 0
      ENDIF
      IF(BRK.LT.0) CALL LISPRPV
      BRK = 0
      END
C -----------------------------------------------------------------------------
      SUBROUTINE COSSEEK (IOC,IADDR,BLKSIZE)
C
      IMPLICIT INTEGER(A-Z)
      COMMON /IOSTUF/ BRK,ERR, FILEDN(32), FILEPDN(2,32), INUSE(32)
     *               , IDF(2) , DEFO(3)
C
      BRK = 17
      CALL SEEK(FILEDN(IOC),IADDR,BLKSIZE,ERR)
      IOC=ERR
      ERR = 0
      IF(BRK.LT.0) CALL LISPRPV
      BRK = 0
      END
C
C -----------------------------------------------------------------------------
      SUBROUTINE COSWREB (IOC,IADDR,BLKADR,BLKSIZE)
C
      IMPLICIT INTEGER(A-Z)
      COMMON /IOSTUF/ BRK,ERR, FILEDN(32), FILEPDN(2,32), INUSE(32)
     *               , IDF(2) , DEFO(3)
      POINTER(BLKADR,MEM)
C
      BRK = 17
      CALL GETWA(FILEDN(IOC),MEM,IADDR,BLKSIZE,ERR)
      IOC=ERR
      ERR = 0
      IF(BRK.LT.0) CALL LISPRPV
      BRK = 0
      END
C
C -----------------------------------------------------------------------------
      SUBROUTINE COSWWRW (IOC,IADDR,WTOWRIT)
C
      IMPLICIT INTEGER(A-Z)
      COMMON /IOSTUF/ BRK,ERR, FILEDN(32), FILEPDN(2,32), INUSE(32)
     *               , IDF(2) , DEFO(3)
C
      BRK = 17
      CALL APUTWA(FILEDN(IOC),WTOWRIT,IADDR,1,ERR)
      IOC=ERR
      ERR = 0
      IF(BRK.LT.0) CALL LISPRPV
      BRK = 0
      END
C -----------------------------------------------------------------------------
      SUBROUTINE COSWWRB (IOC,IADDR,BLKADR,BLKSIZE)
C
      IMPLICIT INTEGER(A-Z)
      COMMON /IOSTUF/ BRK,ERR, FILEDN(32), FILEPDN(2,32), INUSE(32)
     *               , IDF(2) , DEFO(3)
      POINTER(BLKADR,MEM)
C
      BRK = 17
      CALL APUTWA(FILEDN(IOC),MEM,IADDR,BLKSIZE,ERR)
      IOC=ERR
      ERR = 0
      IF(BRK.LT.0) CALL LISPRPV
      BRK = 0
      END
C -----------------------------------------------------------------------------
      SUBROUTINE COSWCLS (IOC)
C
      IMPLICIT INTEGER(A-Z)
C
      COMMON /IOPARAM/ MSG,WAIT
      LOGICAL WAIT,MSG
      COMMON /IOSTUF/ BRK,ERR, FILEDN(32), FILEPDN(2,32), INUSE(32)
     *               , IDF(2) , DEFO(3)
C
      BRK = 17
      CALL WCLOSE(FILEDN(IOC),ERR)
C
      INUSE(IOC)=0
      IOC=ERR
      ERR = 0
      IF(BRK.LT.0) CALL LISPRPV
      BRK = 0
      END
C =============================================================================
C  Connect a full length library name to a local name
C
      SUBROUTINE LIBNAME(NAMEPTR,IOC)
C
      IMPLICIT INTEGER(A-Z)
 
      INTEGER FILENAME(32)
      POINTER (NAMEPTR,FILENAME)
      CHARACTER*1 NAME(255)
      CHARACTER*255 NAMECHR
      CHARACTER*8 LOCNAME
      CHARACTER*200 COMMAND
      COMMON /LIBDIR/LIBDIR
      COMMON /LIBDA/LIBDA
      LOGICAL LIBDA
      CHARACTER*255 LIBDIR
      EQUIVALENCE(NAME,NAMECHR)
C
      CHARACTER*255 NAMAUX
      DATA LIBNR /10/
C
C convert LISP string to FORTRAN
C
      NAMAUX = ' '
      NAMECHR = ' '
      WRITE(NAMECHR,'(31A8,A7)') FILENAME
C
      DO 9 I=1,255
      IF (LIBDIR(I:I) .EQ. CHAR(0) .OR. LIBDIR(I:I) .EQ. ' ') GOTO 901
      NAMAUX(I:I) = LIBDIR(I:I)
9     CONTINUE
C
901   IF (I .NE. 1) THEN
         NAMAUX(I:I) = '/'
         I=I+1
      ENDIF
C
      K = 1
      DO 10 I=I,255
      IF (NAME(K) .EQ. CHAR(0)) GOTO 11
        IF (NAME(K) .LE. 'Z' .AND. NAME(K) .GE. 'A') THEN
           NAMAUX(I:I) = CHAR(ICHAR(NAME(K))+32)
        ELSE
           NAMAUX(I:I) = NAME(K)
        ENDIF
        K = K + 1
10    CONTINUE
C test the existence of the library file
11    LTH = I-1
      INQUIRE(FILE=NAMAUX,EXIST=LIBDA)
 
      WRITE(LOCNAME,'(A,I2)') ' fort.',IOC+60
 
C
C the shell command for linkage is constructed next
C
      DO 17 I=1,200
17    COMMAND (I:I) = CHAR(0)
      WRITE(COMMAND,'(200A)')
     *             'assign -a ',
     *             (NAMAUX(I:I),I=1,LTH),
     *             ' ',
     *             LOCNAME
      DO 171 I=190,200
171   COMMAND (I:I) = CHAR(0)
C      WRITE(6,'(A,A)')' command to be invoked: ',COMMAND
      CALL SETWIPF
      CALL JSHELL(COMMAND)
      RETURN
      END
C
C----------------------------------------------------------------------
      SUBROUTINE NAMETRF(NAMEPTR,NAMCHR)
C
      IMPLICIT INTEGER(A-Z)
 
      INTEGER FILENAME(32)
      POINTER (NAMEPTR,FILENAME)
      CHARACTER *1 NAME(255)
      CHARACTER*255 NAMECHR,NAMCHR
      EQUIVALENCE (NAME,NAMECHR)
C
C convert LISP string to FORTRAN
C
      NAMECHR = ' '
      WRITE(NAMECHR,'(31A8,A7)') FILENAME
C
      DO 10 I=1,255
      IF (NAME(I) .EQ. CHAR(0)) GOTO 11
10    CONTINUE
11    CONTINUE
      DO 12 I=I,255
      NAME(I) = ' '
12    CONTINUE
      NAMCHR=NAMECHR
      RETURN
      END
C ============================================================================
