%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PNK:ONOFF.SL 
% Title:        Macros for setting/resetting flags, with SIMPFG hook 
% Author:       Martin Griss 
% Created:      21 July 1982 
% Modified:     22-Mar-84 11:38:14 (Brian Beach) 
% Status:       Experimental 
% Mode:         Lisp 
% Package:      Kernel 
% Compiletime:  
% Runtime:      
%
% (c) Copyright 1983, Hewlett-Packard Company, all rights reserved.
% (c) Copyright 1982, University of Utah
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
% 01-Dec-83 14:55:30 (Brian Beach)
%   Translated from Rlisp to Lisp.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(de onoff* (idlist u)
  %
  % IdList is list of variables without !* prefix, U is T or NIL
  %
  (prog (y)
        (foreach x in idlist do (if (not (idp x))
                   (noniderror x (if (null u)
                      'off
                      'on))
                   (progn (set (mkflagvar x) u)
                          (when (setq y (atsoc u (get x 'simpfg)))
                            (eval (second y))))))))

(de mkflagvar (u)
  % Should be redefined in PACKAGE.RED
  (intern (concat "*" (id2string u))))

% to lambda-bind current pkg to GLOBAL
(dm on (u)
  (list 'onoff* (mkquote (cdr u)) t))

(dm off (u)
  (list 'onoff* (mkquote (cdr u)) nil))

(flag '(on off) 'ignore)

